#!/bin/bash

set -e

COMPOSE_FILE="/etc/docker/mds/docker-xivomds.yml"


is_postgres_running_on_port() {
    result=$(psql -h localhost -p $1 -U postgres --quiet -tAc "SELECT 1 FROM pg_catalog.pg_database WHERE datname='$2'" 2> /dev/null)

    [ $? -eq 0 ] && [ "$result" = "1" ]
}

pull_and_start_db() {
    xivo-dcomp upgrade-db
}

wait_for_postgres() {
    local wait_time=600
    echo -n "Waiting $wait_time seconds for database $2 on port $1..."

    local db_running="false"
    for i in $(seq 1 $wait_time); do
        if is_postgres_running_on_port "$1" "$2"; then
            db_running="true"
            break
        else
            sleep 1
            echo -n "."
        fi
    done
    echo
    if [ "$db_running" = "false" ]; then
        echo "ERROR: database is not running."
    fi
}

ensure_user_group_postgres() {
    if ! getent group postgres &> /dev/null; then
        groupadd -r postgres
    fi

    if ! getent passwd postgres &> /dev/null; then
        useradd -r -g postgres --home-dir=/var/lib/postgresql --shell=/bin/bash -c "PostgreSQL administrator" postgres
    fi

    if [ ! -d /var/lib/postgresql ]; then
        mkdir -p /var/lib/postgresql
        chown -R postgres:postgres /var/lib/postgresql
    fi

    if [ ! -d /var/log/postgresql ]; then
        mkdir -p /var/log/postgresql
        chown -R postgres:postgres /var/log/postgresql
    fi

    # Check default group for postgres
    local POSTGRES_USER_GROUP=$(id -gn postgres)
    if [ "$POSTGRES_USER_GROUP" != "postgres" ]; then
        usermod -g postgres postgres
    fi
}

create_pgpass_file() {
    echo "Overwriting .pgpass file"
    echo "localhost:5432:asterisk:asterisk:proformatique" > /root/.pgpass
    echo "localhost:5432:postgres:postgres:proformatique" >> /root/.pgpass
    echo "localhost:5432:asterisk:postgres:proformatique" >> /root/.pgpass
    echo "localhost:5433:asterisk:asterisk:proformatique" >> /root/.pgpass
    echo "localhost:5433:postgres:postgres:proformatique" >> /root/.pgpass
    echo "localhost:5433:asterisk:postgres:proformatique" >> /root/.pgpass
    chmod 600 /root/.pgpass
}

init_postgres_db() {
    create_pgpass_file
    pull_and_start_db
    wait_for_postgres 5432 asterisk
}

migrate_to_postgres_15() {

    xivo-dcomp stop db
    xivo-dcomp rm -f db
    rm -rf /var/lib/postgresql/11

    init_postgres_db

    echo -e "\e[1;33mPostgres 15 is installed.\e[0m"
}


case "$1" in
    configure)
        ensure_user_group_postgres
        
        if [ -z "$2" ]; then
            # First installation

            init_postgres_db
        else
            # Upgrade
            previous_version=$2

            if dpkg --compare-versions "$previous_version" "<<" "2023.04.00"; then
                migrate_to_postgres_15
            fi
        fi
    ;;

    abort-upgrade)
    ;;

    *)
        echo "postinst called with unknown argument \`$1'" >&2
        exit 1
    ;;
esac

# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.

#DEBHELPER#

exit 0
